/**
 * A class for rational numbers
 * wihout side effects at mult and toStringReduced
 */
public class Rational {

	// instance variables
	private int num;
	private int denom;

	// Constructors
	public Rational() {
		num = 0;
		denom = 1;
	}

	public Rational(int n) {
	   num = n;
	   denom = 1;
	}

	public Rational(int num, int denom) {
		this(num);
		if (denom == 0) {
			throw new RuntimeException("Denominator is zero!");
		}
		this.denom = denom;
	}

	// method: reduce
	public Rational reduce() {
		int gcd = Gcd.gcd(num, denom);
		return new Rational(num/gcd, denom/gcd);
	}

	// method: extend
	public Rational extend(int factor) {
		return new Rational(num * factor, denom * factor);
	}

	// method: print as a/b
	public String toString() {
		return (num + "/" + denom);
	}

	// method: print reduced
	public String toStringReduced() {
		Rational out = new Rational(num, denom);
		out = out.reduce();
		return out.toString();
	}

	// methode: multiply
	public Rational mult(Rational p) {
		int gcd = Gcd.gcd(p.num, p.denom);
		int n = p.num/gcd;
		int d = p.denom/gcd;
		return new Rational(num*n, denom*d);
	}
}

